///////////////////////////////////////////////////////////////////////////////////
//KrFilterGtFNg
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;


float Si10 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;


static float Si=Si10*0.1;

float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}


////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passFilter(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ScnSamp, Tex);
	Color.rgb = saturate(Color);

	float3 ColorB = Color.rgb;

	//J[/Y
	float3 Color2 = (Color.rgb - 0.5) * 2;
	float3 Color3 = (1.0 - pow(1.0 - abs(Color2), 2.0))*sign(Color2)*0.5 + 0.5;
	float3 Color4 = lerp(Color.rgb, Color3, float3(1.0,-0.5,-1.0));
	//Color4.rgb = lerp(Color4.rgb, Color.rgb,saturate(Color.g/(Color.r+Color.b)));
	Color.rgb = lerp(ColorB.rgb, Color4, Si*Tr);

	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////

technique FILTER <
	string Script =

	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Filter;"

	;

> {
	pass Filter < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passFilter();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
